Tool: create_instance
Create a Memorystore for Redis instance.
The following sample demonstrate how to use curl to invoke the create_instance MCP tool.
| Curl Request |
|---|
curl --location 'https://redis.googleapis.com/mcp' \ --header 'content-type: application/json' \ --header 'accept: application/json, text/event-stream' \ --data '{ "method": "tools/call", "params": { "name": "create_instance", "arguments": { // provide these details according to the tool's MCP specification } }, "jsonrpc": "2.0", "id": 1 }' |
Input Schema
Request for CreateInstance.
CreateInstanceRequest
| JSON representation |
|---|
{
"parent": string,
"instanceId": string,
"instance": {
object ( |
| Fields | |
|---|---|
parent |
Required. The resource name of the instance location using the form: |
instanceId |
Required. The logical name of the Redis instance in the customer project with the following restrictions:
|
instance |
Required. A Redis [Instance] resource |
Instance
| JSON representation |
|---|
{ "name": string, "displayName": string, "labels": { string: string, ... }, "locationId": string, "alternativeLocationId": string, "redisVersion": string, "reservedIpRange": string, "secondaryIpRange": string, "host": string, "port": integer, "currentLocationId": string, "createTime": string, "state": enum ( |
| Fields | |
|---|---|
name |
Required. Unique name of the resource in this scope including project and location using the form: Note: Redis instances are managed and addressed at regional level so location_id here refers to a GCP region; however, users may choose which specific zone (or collection of zones for cross-zone instances) an instance should be provisioned in. Refer to |
displayName |
An arbitrary and optional user-provided name for the instance. |
labels |
Resource labels to represent user provided metadata An object containing a list of |
locationId |
Optional. The zone where the instance will be provisioned. If not provided, the service will choose a zone from the specified region for the instance. For standard tier, additional nodes will be added across multiple zones for protection against zonal failures. If specified, at least one node will be provisioned in this zone. |
alternativeLocationId |
Optional. If specified, at least one node will be provisioned in this zone in addition to the zone specified in location_id. Only applicable to standard tier. If provided, it must be a different zone from the one provided in [location_id]. Additional nodes beyond the first 2 will be placed in zones selected by the service. |
redisVersion |
Optional. The version of Redis software. If not provided, the default version will be used. Currently, the supported values are:
|
reservedIpRange |
Optional. For DIRECT_PEERING mode, the CIDR range of internal addresses that are reserved for this instance. Range must be unique and non-overlapping with existing subnets in an authorized network. For PRIVATE_SERVICE_ACCESS mode, the name of one allocated IP address ranges associated with this private service access connection. If not provided, the service will choose an unused /29 block, for example, 10.0.0.0/29 or 192.168.0.0/29. For READ_REPLICAS_ENABLED the default block size is /28. |
secondaryIpRange |
Optional. Additional IP range for node placement. Required when enabling read replicas on an existing instance. For DIRECT_PEERING mode value must be a CIDR range of size /28, or "auto". For PRIVATE_SERVICE_ACCESS mode value must be the name of an allocated address range associated with the private service access connection, or "auto". |
host |
Output only. Hostname or IP address of the exposed Redis endpoint used by clients to connect to the service. |
port |
Output only. The port number of the exposed Redis endpoint. |
currentLocationId |
Output only. The current zone where the Redis primary node is located. In basic tier, this will always be the same as [location_id]. In standard tier, this can be the zone of any node in the instance. |
createTime |
Output only. The time the instance was created. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: |
state |
Output only. The current state of this instance. |
statusMessage |
Output only. Additional information about the current status of this instance, if available. |
redisConfigs |
Optional. Redis configuration parameters, according to Redis configuration. Currently, the only supported parameters are: Redis version 3.2 and newer:
Redis version 4.0 and newer:
Redis version 5.0 and newer:
An object containing a list of |
tier |
Required. The service tier of the instance. |
memorySizeGb |
Required. Redis memory size in GiB. |
authorizedNetwork |
Optional. The full name of the Google Compute Engine network to which the instance is connected. If left unspecified, the |
persistenceIamIdentity |
Output only. Cloud IAM identity used by import / export operations to transfer data to/from Cloud Storage. Format is "serviceAccount: |
connectMode |
Optional. The network connect mode of the Redis instance. If not provided, the connect mode defaults to DIRECT_PEERING. |
authEnabled |
Optional. Indicates whether OSS Redis AUTH is enabled for the instance. If set to "true" AUTH is enabled on the instance. Default value is "false" meaning AUTH is disabled. |
serverCaCerts[] |
Output only. List of server CA certificates for the instance. |
transitEncryptionMode |
Optional. The TLS mode of the Redis instance. If not provided, TLS is disabled for the instance. |
maintenancePolicy |
Optional. The maintenance policy for the instance. If not provided, maintenance events can be performed at any time. |
maintenanceSchedule |
Output only. Date and time of upcoming maintenance events which have been scheduled. |
replicaCount |
Optional. The number of replica nodes. The valid range for the Standard Tier with read replicas enabled is [1-5] and defaults to 2. If read replicas are not enabled for a Standard Tier instance, the only valid value is 1 and the default is 1. The valid value for basic tier is 0 and the default is also 0. |
nodes[] |
Output only. Info per node. |
readEndpoint |
Output only. Hostname or IP address of the exposed readonly Redis endpoint. Standard tier only. Targets all healthy replica nodes in instance. Replication is asynchronous and replica nodes will exhibit some lag behind the primary. Write requests must target 'host'. |
readEndpointPort |
Output only. The port number of the exposed readonly redis endpoint. Standard tier only. Write requests should target 'port'. |
readReplicasMode |
Optional. Read replicas mode for the instance. Defaults to READ_REPLICAS_DISABLED. |
customerManagedKey |
Optional. The KMS key reference that the customer provides when trying to create the instance. |
persistenceConfig |
Optional. Persistence configuration parameters |
suspensionReasons[] |
Optional. reasons that causes instance in "SUSPENDED" state. |
maintenanceVersion |
Optional. The self service update maintenance version. The version is date based such as "20210712_00_00". |
availableMaintenanceVersions[] |
Optional. The available maintenance versions that an instance could update to. |
tags |
Optional. Input only. Immutable. Tag keys/values directly bound to this resource. For example: "123/environment": "production", "123/costCenter": "marketing" An object containing a list of |
Union field
|
|
satisfiesPzs |
Optional. Output only. Reserved for future use. |
Union field
|
|
satisfiesPzi |
Optional. Output only. Reserved for future use. |
LabelsEntry
| JSON representation |
|---|
{ "key": string, "value": string } |
| Fields | |
|---|---|
key |
|
value |
|
Timestamp
| JSON representation |
|---|
{ "seconds": string, "nanos": integer } |
| Fields | |
|---|---|
seconds |
Represents seconds of UTC time since Unix epoch 1970-01-01T00:00:00Z. Must be between -62135596800 and 253402300799 inclusive (which corresponds to 0001-01-01T00:00:00Z to 9999-12-31T23:59:59Z). |
nanos |
Non-negative fractions of a second at nanosecond resolution. This field is the nanosecond portion of the duration, not an alternative to seconds. Negative second values with fractions must still have non-negative nanos values that count forward in time. Must be between 0 and 999,999,999 inclusive. |
RedisConfigsEntry
| JSON representation |
|---|
{ "key": string, "value": string } |
| Fields | |
|---|---|
key |
|
value |
|
TlsCertificate
| JSON representation |
|---|
{ "serialNumber": string, "cert": string, "createTime": string, "expireTime": string, "sha1Fingerprint": string } |
| Fields | |
|---|---|
serialNumber |
Serial number, as extracted from the certificate. |
cert |
PEM representation. |
createTime |
Output only. The time when the certificate was created in RFC 3339 format, for example Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: |
expireTime |
Output only. The time when the certificate expires in RFC 3339 format, for example Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: |
sha1Fingerprint |
Sha1 Fingerprint of the certificate. |
MaintenancePolicy
| JSON representation |
|---|
{
"createTime": string,
"updateTime": string,
"description": string,
"weeklyMaintenanceWindow": [
{
object ( |
| Fields | |
|---|---|
createTime |
Output only. The time when the policy was created. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: |
updateTime |
Output only. The time when the policy was last updated. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: |
description |
Optional. Description of what this policy is for. Create/Update methods return INVALID_ARGUMENT if the length is greater than 512. |
weeklyMaintenanceWindow[] |
Optional. Maintenance window that is applied to resources covered by this policy. Minimum 1. For the current version, the maximum number of weekly_window is expected to be one. |
WeeklyMaintenanceWindow
| JSON representation |
|---|
{ "day": enum ( |
| Fields | |
|---|---|
day |
Required. The day of week that maintenance updates occur. |
startTime |
Required. Start time of the window in UTC time. |
duration |
Output only. Duration of the maintenance window. The current window is fixed at 1 hour. A duration in seconds with up to nine fractional digits, ending with ' |
TimeOfDay
| JSON representation |
|---|
{ "hours": integer, "minutes": integer, "seconds": integer, "nanos": integer } |
| Fields | |
|---|---|
hours |
Hours of a day in 24 hour format. Must be greater than or equal to 0 and typically must be less than or equal to 23. An API may choose to allow the value "24:00:00" for scenarios like business closing time. |
minutes |
Minutes of an hour. Must be greater than or equal to 0 and less than or equal to 59. |
seconds |
Seconds of a minute. Must be greater than or equal to 0 and typically must be less than or equal to 59. An API may allow the value 60 if it allows leap-seconds. |
nanos |
Fractions of seconds, in nanoseconds. Must be greater than or equal to 0 and less than or equal to 999,999,999. |
Duration
| JSON representation |
|---|
{ "seconds": string, "nanos": integer } |
| Fields | |
|---|---|
seconds |
Signed seconds of the span of time. Must be from -315,576,000,000 to +315,576,000,000 inclusive. Note: these bounds are computed from: 60 sec/min * 60 min/hr * 24 hr/day * 365.25 days/year * 10000 years |
nanos |
Signed fractions of a second at nanosecond resolution of the span of time. Durations less than one second are represented with a 0 |
MaintenanceSchedule
| JSON representation |
|---|
{ "startTime": string, "endTime": string, "canReschedule": boolean, "scheduleDeadlineTime": string } |
| Fields | |
|---|---|
startTime |
Output only. The start time of any upcoming scheduled maintenance for this instance. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: |
endTime |
Output only. The end time of any upcoming scheduled maintenance for this instance. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: |
canReschedule |
If the scheduled maintenance can be rescheduled, default is true. |
scheduleDeadlineTime |
Output only. The deadline that the maintenance schedule start time can not go beyond, including reschedule. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: |
NodeInfo
| JSON representation |
|---|
{ "id": string, "zone": string } |
| Fields | |
|---|---|
id |
Output only. Node identifying string. e.g. 'node-0', 'node-1' |
zone |
Output only. Location of the node. |
PersistenceConfig
| JSON representation |
|---|
{ "persistenceMode": enum ( |
| Fields | |
|---|---|
persistenceMode |
Optional. Controls whether Persistence features are enabled. If not provided, the existing value will be used. |
rdbSnapshotPeriod |
Optional. Period between RDB snapshots. Snapshots will be attempted every period starting from the provided snapshot start time. For example, a start time of 01/01/2033 06:45 and SIX_HOURS snapshot period will do nothing until 01/01/2033, and then trigger snapshots every day at 06:45, 12:45, 18:45, and 00:45 the next day, and so on. If not provided, TWENTY_FOUR_HOURS will be used as default. |
rdbNextSnapshotTime |
Output only. The next time that a snapshot attempt is scheduled to occur. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: |
rdbSnapshotStartTime |
Optional. Date and time that the first snapshot was/will be attempted, and to which future snapshots will be aligned. If not provided, the current time will be used. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: |
TagsEntry
| JSON representation |
|---|
{ "key": string, "value": string } |
| Fields | |
|---|---|
key |
|
value |
|
Output Schema
This resource represents a long-running operation that is the result of a network API call.
Operation
| JSON representation |
|---|
{ "name": string, "metadata": { "@type": string, field1: ..., ... }, "done": boolean, // Union field |
| Fields | |
|---|---|
name |
The server-assigned name, which is only unique within the same service that originally returns it. If you use the default HTTP mapping, the |
metadata |
{
} An object containing fields of an arbitrary type. An additional field |
done |
If the value is |
Union field result. The operation result, which can be either an error or a valid response. If done == false, neither error nor response is set. If done == true, exactly one of error or response can be set. Some services might not provide the result. result can be only one of the following: |
|
error |
The error result of the operation in case of failure or cancellation. |
response |
The normal, successful response of the operation. If the original method returns no data on success, such as An object containing fields of an arbitrary type. An additional field |
Any
| JSON representation |
|---|
{ "typeUrl": string, "value": string } |
| Fields | |
|---|---|
typeUrl |
Identifies the type of the serialized Protobuf message with a URI reference consisting of a prefix ending in a slash and the fully-qualified type name. Example: type.googleapis.com/google.protobuf.StringValue This string must contain at least one The prefix is arbitrary and Protobuf implementations are expected to simply strip off everything up to and including the last All type URL strings must be legal URI references with the additional restriction (for the text format) that the content of the reference must consist only of alphanumeric characters, percent-encoded escapes, and characters in the following set (not including the outer backticks): In the original design of |
value |
Holds a Protobuf serialization of the type described by type_url. A base64-encoded string. |
Status
| JSON representation |
|---|
{ "code": integer, "message": string, "details": [ { "@type": string, field1: ..., ... } ] } |
| Fields | |
|---|---|
code |
The status code, which should be an enum value of |
message |
A developer-facing error message, which should be in English. Any user-facing error message should be localized and sent in the |
details[] |
A list of messages that carry the error details. There is a common set of message types for APIs to use. An object containing fields of an arbitrary type. An additional field |
Tool Annotations
Destructive Hint: ❌ | Idempotent Hint: ❌ | Read Only Hint: ❌ | Open World Hint: ❌